/* ************************ */
/*                          */
/* Adept - Squish Converter */
/*                    by BK */
/* ************************ */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

tmp=syscls()


/* NOTE:
This small rexx script will read out any required information for squish.cfg so you don't have
to type in manually all your areas setup in adept.

Change this script as you want, but please send a copy to Klaus.Ader@rz.ruhr-uni-bochu.de

You might want to change the search for NETMAIL area from name-search into flag-search btw change the
search-name for your NETMAIL area.
*/




/* SETUP */

main_aka="2:2448/391"                                   /* Your MAIN AKA         */
areafile="c:\adept\area.control"                        /* path and filename     */
msgfile="c:\adept\system\message_areas"                 /* path and filename     */
outfile="c:\adept\tools\fastecho\SQUISH.CFG"            /* path and filename     */
out="c:\adept\tools\fastecho\message_areas.squish"      /* path and filename     */
msgbase="C:\adept\message_bases\"                       /* path to your msg base */

purge_msg=700                                           /* Purge Squish base down to x messages - no purge: 0 */
purge_day=28                                            /* Purge older than x days - no purge: 0 */
/* ***** */


tmp=Sysfiledelete(outfile)

i=1
rc_open = STREAM( (msgfile) , "C" , "OPEN" )
rc_open = STREAM( (out) , "C" , "OPEN" )
do while lines(msgfile)
	line=linein(msgfile)
	tmp=lineout(out, line)
	parse upper value line with argument rest .
	argument=strip(argument, "B")
	if argument="AREABEGIN" then do
		line=linein(msgfile)
		tmp=lineout(out, line)
		parse upper value line with argument name rest .
		argument=strip(argument, "B")
		if argument="NAME" then do
		 area.i=strip(name, "B")
		end

		do until argument="AREAEND"
			line=linein(msgfile)
			parse upper value line with argument rest
			argument=strip(argument, "B")
			if argument="FLAGS" then do             /* convert to squish */
				flag=strip(rest, "B")
				if flag < 32768 then flag=flag+32768
				line="  FLAGS    "||flag
			end
			tmp=lineout(out, line)
			if argument="ORIGIN" then do             /* create squish origin .SQO files */
				new_out=msgbase||area.i||".SQO"
				new_origin=strip(rest, "B")
				rc_open = STREAM( (new_out) , "C" , "OPEN" )
				tmp=lineout(new_out, new_origin)
				rc_open = STREAM( (new_out) , "C" , "CLOSE" )
			end
		
			if argument="PATH" then	area_pfad.i=strip(rest, "B")
			if argument="ADDRESS" then do 
				address=strip(rest, "B")
				last=lastpos(".", address)
				area_address.i=substr(address, 1, last-1)
			end
		end
		i=i+1
	end

end
rc_open = STREAM( (msgfile) , "C" , "CLOSE" )
rc_open = STREAM( (out) , "C" , "CLOSE" )
anzahl_area=i


i=1
rc_open = STREAM( (areafile) , "C" , "OPEN" )
do while lines(areafile)
	line=strip(linein(areafile), "B")
	parse upper value line with argument rest .
	if argument="ECHO" then do
		parse upper value line with argument name number uplink downlink
		echo.i=strip(name, "B")
		uplink=strip(uplink, "B")
		last=lastpos("@", uplink)
		if last > 0 then do
			uplink.i=substr(uplink, 1, last-1)
		end
		else do
			uplink.i=strip(uplink, "B")
		end
		if downlink \= "" then do
			downlink=strip(downlink, "B")
			downlink=downlink||" "
			first=pos("@", downlink)

			if first > 0 then do
				do until first=0	
					blank=pos(" ", downlink, first)
					anzahl=blank-first
					downlink=delstr(downlink, first, anzahl)
					first=pos("@", downlink)
				end
			end
		end
		downlink.i=downlink
		i=i+1
	end
end
rc_open = STREAM( (areafile) , "C" , "CLOSE" )
anzahl_echo=i

rc_open = STREAM( (outfile) , "C" , "OPEN" )

tmp=lineout(outfile, ";")
tmp=lineout(outfile, "; Created by Adept to Squish Converter")
tmp=lineout(outfile, ";                               BK '97")
tmp=lineout(outfile, ";")
tmp=lineout(outfile, "")
line="Address "||main_aka
tmp=lineout(outfile, line)
tmp=lineout(outfile, "")


/* NETMAIL AREA ... change the name if required */

do i=1 to anzahl_area
	if area.i="NETMAIL" then do
				areapfad=strip(area_pfad.i, "T", "\")
				line="NetArea   "||area.i||"  "||areapfad||"    -$"
				tmp=lineout(outfile, line)
				line="BadArea   BADMAIL  "||areapfad||"\BAD  -$"
				tmp=lineout(outfile, line)
				line="DupeArea  DUPE     "||areapfad||"\DUPE -$"
				tmp=lineout(outfile, line)
				tmp=lineout(outfile, "")
				leave
	end
end

do i=1 to anzahl_area
	if area.i="NETMAIL" then iterate
	do j=1 to anzahl_echo
		if area.i=echo.j then do
				line="EchoArea    "echo.j
				laenge=length(line)
				space=""
				do z=1 to (40-laenge)
					space=space||" "
				end
				line=line||space||area_pfad.i||echo.j
				laenge=length(line)
				space=""
				do z=1 to (90-laenge)
					space=space||" "
				end
				if (purge_msg>0)&(purge_day>0) then do
					line=line||space||" -$ -$m"||purge_msg||" -$d"||purge_day||" -p"||area_address.i||" "
				end
				else do
					line=line||space||" -$  -p"||area_address.i||" "
				end

				laenge=length(line)
				space=""
				do z=1 to (120-laenge)
					space=space||" "
				end
				line=line||space||" "||uplink.j||" "||downlink.j
				tmp=lineout(outfile, line)
				leave		
		end
		else do
			iterate
		end
	end
end
rc_open = STREAM( (outfile) , "C" , "CLOSE" )

say ""
say ""
say center("   *****************************",70)
say center("   * Adept to Squish Converter *",70)
say center("   *                           *",70)
say center("   *     --==BREAKDOWN==--     *",70)
say center("   *                           *",70)
say center("   *****************************",70)
say center("                          BK'97 ",70)
say ""

say "   *** "||anzahl_area||" areas found in message_areas"
say "   *** "||anzahl_echo||" echos found in area.control"
say ""
if (anzahl_area<=anzahl_echo) then do
	say "   *** "||anzahl_area||" converted - "||outfile||" successful created"
	say "   *** "||anzahl_echo-anzahl_area||" areas must be added manually!"
end
else do
	say "   *** "||anzahl_area||" converted - "||outfile||" successful created"
	say "   *** "||anzahl_area-anzahl_echo||" areas must be added manually!"
end
say ""
say "   *** DONE!"
